/* popupwebview.c generated by valac 0.26.1, the Vala compiler
 * generated from popupwebview.vala, do not modify */

/*
 * Copyright 2011-2012 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <webkit/webkit.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define NUVOLA_TYPE_WEB_VIEW (nuvola_web_view_get_type ())
#define NUVOLA_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_VIEW, NuvolaWebView))
#define NUVOLA_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewClass))
#define NUVOLA_IS_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_VIEW))
#define NUVOLA_IS_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_VIEW))
#define NUVOLA_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewClass))

typedef struct _NuvolaWebView NuvolaWebView;
typedef struct _NuvolaWebViewClass NuvolaWebViewClass;
typedef struct _NuvolaWebViewPrivate NuvolaWebViewPrivate;

#define NUVOLA_TYPE_POPUP_WEB_VIEW (nuvola_popup_web_view_get_type ())
#define NUVOLA_POPUP_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_POPUP_WEB_VIEW, NuvolaPopupWebView))
#define NUVOLA_POPUP_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_POPUP_WEB_VIEW, NuvolaPopupWebViewClass))
#define NUVOLA_IS_POPUP_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_POPUP_WEB_VIEW))
#define NUVOLA_IS_POPUP_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_POPUP_WEB_VIEW))
#define NUVOLA_POPUP_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_POPUP_WEB_VIEW, NuvolaPopupWebViewClass))

typedef struct _NuvolaPopupWebView NuvolaPopupWebView;
typedef struct _NuvolaPopupWebViewClass NuvolaPopupWebViewClass;
typedef struct _NuvolaPopupWebViewPrivate NuvolaPopupWebViewPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NuvolaWebView {
	WebKitWebView parent_instance;
	NuvolaWebViewPrivate * priv;
};

struct _NuvolaWebViewClass {
	WebKitWebViewClass parent_class;
};

struct _NuvolaPopupWebView {
	NuvolaWebView parent_instance;
	NuvolaPopupWebViewPrivate * priv;
};

struct _NuvolaPopupWebViewClass {
	NuvolaWebViewClass parent_class;
};

struct _NuvolaPopupWebViewPrivate {
	GtkDialog* dialog;
};


static gpointer nuvola_popup_web_view_parent_class = NULL;

GType nuvola_web_view_get_type (void) G_GNUC_CONST;
GType nuvola_popup_web_view_get_type (void) G_GNUC_CONST;
#define NUVOLA_POPUP_WEB_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_POPUP_WEB_VIEW, NuvolaPopupWebViewPrivate))
enum  {
	NUVOLA_POPUP_WEB_VIEW_DUMMY_PROPERTY
};
NuvolaPopupWebView* nuvola_popup_web_view_new (WebKitWebSettings* settings);
NuvolaPopupWebView* nuvola_popup_web_view_construct (GType object_type, WebKitWebSettings* settings);
NuvolaWebView* nuvola_web_view_new (void);
NuvolaWebView* nuvola_web_view_construct (GType object_type);
static gboolean nuvola_popup_web_view_real_web_view_ready (WebKitWebView* base);
static void __lambda10_ (NuvolaPopupWebView* self, WebKitWebView* source, WebKitWebFrame* frame, const gchar* title);
static void ___lambda10__webkit_web_view_title_changed (WebKitWebView* _sender, WebKitWebFrame* p0, const gchar* p1, gpointer self);
static gboolean nuvola_popup_web_view_real_close_web_view (WebKitWebView* base);
static void nuvola_popup_web_view_finalize (GObject* obj);


/**
 * Creates new PopupView.
 * 
 * @param settings settings for WebView
 */
NuvolaPopupWebView* nuvola_popup_web_view_construct (GType object_type, WebKitWebSettings* settings) {
	NuvolaPopupWebView * self = NULL;
	WebKitWebSettings* _tmp0_ = NULL;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	self = (NuvolaPopupWebView*) nuvola_web_view_construct (object_type);
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp0_ = webkit_web_view_get_settings ((WebKitWebView*) self);
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	webkit_web_view_set_settings ((WebKitWebView*) self, _tmp0_);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	return self;
#line 122 "popupwebview.c"
}


NuvolaPopupWebView* nuvola_popup_web_view_new (WebKitWebSettings* settings) {
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	return nuvola_popup_web_view_construct (NUVOLA_TYPE_POPUP_WEB_VIEW, settings);
#line 129 "popupwebview.c"
}


static void __lambda10_ (NuvolaPopupWebView* self, WebKitWebView* source, WebKitWebFrame* frame, const gchar* title) {
	GtkDialog* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_return_if_fail (source != NULL);
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_return_if_fail (frame != NULL);
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_return_if_fail (title != NULL);
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp0_ = self->priv->dialog;
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp1_ = title;
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_window_set_title ((GtkWindow*) _tmp0_, _tmp1_);
#line 148 "popupwebview.c"
}


static void ___lambda10__webkit_web_view_title_changed (WebKitWebView* _sender, WebKitWebFrame* p0, const gchar* p1, gpointer self) {
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	__lambda10_ ((NuvolaPopupWebView*) self, _sender, p0, p1);
#line 155 "popupwebview.c"
}


static gboolean nuvola_popup_web_view_real_web_view_ready (WebKitWebView* base) {
	NuvolaPopupWebView * self;
	gboolean result = FALSE;
	GtkDialog* _tmp0_ = NULL;
	GtkScrolledWindow* sw = NULL;
	GtkScrolledWindow* _tmp1_ = NULL;
	GtkDialog* _tmp2_ = NULL;
	GtkBox* _tmp3_ = NULL;
	GtkDialog* _tmp4_ = NULL;
	GtkDialog* _tmp5_ = NULL;
	GtkDialog* _tmp6_ = NULL;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	self = (NuvolaPopupWebView*) base;
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp0_ = (GtkDialog*) gtk_dialog_new ();
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_object_ref_sink (_tmp0_);
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_g_object_unref0 (self->priv->dialog);
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	self->priv->dialog = _tmp0_;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp1_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_object_ref_sink (_tmp1_);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	sw = _tmp1_;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp2_ = self->priv->dialog;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp3_ = (GtkBox*) gtk_dialog_get_content_area (_tmp2_);
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, GTK_TYPE_CONTAINER) ? ((GtkContainer*) _tmp3_) : NULL, (GtkWidget*) sw);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_scrolled_window_set_policy (sw, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 54 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_container_add ((GtkContainer*) sw, (GtkWidget*) self);
#line 56 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_object_set ((GtkWidget*) sw, "expand", TRUE, NULL);
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp4_ = self->priv->dialog;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_window_set_title ((GtkWindow*) _tmp4_, " ");
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_signal_connect_object ((WebKitWebView*) self, "title-changed", (GCallback) ___lambda10__webkit_web_view_title_changed, self, 0);
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp5_ = self->priv->dialog;
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_window_set_default_size ((GtkWindow*) _tmp5_, 600, 400);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp6_ = self->priv->dialog;
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp6_);
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	result = TRUE;
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_g_object_unref0 (sw);
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	return result;
#line 218 "popupwebview.c"
}


static gboolean nuvola_popup_web_view_real_close_web_view (WebKitWebView* base) {
	NuvolaPopupWebView * self;
	gboolean result = FALSE;
	GtkDialog* _tmp0_ = NULL;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	self = (NuvolaPopupWebView*) base;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_tmp0_ = self->priv->dialog;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	if (_tmp0_ != NULL) {
#line 232 "popupwebview.c"
		GtkDialog* _tmp1_ = NULL;
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
		_tmp1_ = self->priv->dialog;
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp1_);
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
		_g_object_unref0 (self->priv->dialog);
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
		self->priv->dialog = NULL;
#line 242 "popupwebview.c"
	}
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	result = TRUE;
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	return result;
#line 250 "popupwebview.c"
}


static void nuvola_popup_web_view_class_init (NuvolaPopupWebViewClass * klass) {
#line 29 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	nuvola_popup_web_view_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	g_type_class_add_private (klass, sizeof (NuvolaPopupWebViewPrivate));
#line 29 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	((WebKitWebViewClass *) klass)->web_view_ready = nuvola_popup_web_view_real_web_view_ready;
#line 29 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	((WebKitWebViewClass *) klass)->close_web_view = nuvola_popup_web_view_real_close_web_view;
#line 29 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	G_OBJECT_CLASS (klass)->finalize = nuvola_popup_web_view_finalize;
#line 265 "popupwebview.c"
}


static void nuvola_popup_web_view_instance_init (NuvolaPopupWebView * self) {
#line 29 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	self->priv = NUVOLA_POPUP_WEB_VIEW_GET_PRIVATE (self);
#line 272 "popupwebview.c"
}


static void nuvola_popup_web_view_finalize (GObject* obj) {
	NuvolaPopupWebView * self;
#line 29 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_POPUP_WEB_VIEW, NuvolaPopupWebView);
#line 30 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	_g_object_unref0 (self->priv->dialog);
#line 29 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/popupwebview.vala"
	G_OBJECT_CLASS (nuvola_popup_web_view_parent_class)->finalize (obj);
#line 284 "popupwebview.c"
}


/**
 * PopupView displays content of pages opened by JavaScript function
 * window.open(). These pages are opened in new window.
 */
GType nuvola_popup_web_view_get_type (void) {
	static volatile gsize nuvola_popup_web_view_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_popup_web_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaPopupWebViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_popup_web_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaPopupWebView), 0, (GInstanceInitFunc) nuvola_popup_web_view_instance_init, NULL };
		GType nuvola_popup_web_view_type_id;
		nuvola_popup_web_view_type_id = g_type_register_static (NUVOLA_TYPE_WEB_VIEW, "NuvolaPopupWebView", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_popup_web_view_type_id__volatile, nuvola_popup_web_view_type_id);
	}
	return nuvola_popup_web_view_type_id__volatile;
}



