/* webview.c generated by valac 0.26.1, the Vala compiler
 * generated from webview.vala, do not modify */

/*
 * Copyright 2011-2012 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <webkit/webkit.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>


#define NUVOLA_TYPE_WEB_VIEW (nuvola_web_view_get_type ())
#define NUVOLA_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_WEB_VIEW, NuvolaWebView))
#define NUVOLA_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewClass))
#define NUVOLA_IS_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_WEB_VIEW))
#define NUVOLA_IS_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_WEB_VIEW))
#define NUVOLA_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewClass))

typedef struct _NuvolaWebView NuvolaWebView;
typedef struct _NuvolaWebViewClass NuvolaWebViewClass;
typedef struct _NuvolaWebViewPrivate NuvolaWebViewPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NUVOLA_TYPE_INSPECTOR_WINDOW (nuvola_inspector_window_get_type ())
#define NUVOLA_INSPECTOR_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_INSPECTOR_WINDOW, NuvolaInspectorWindow))
#define NUVOLA_INSPECTOR_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_INSPECTOR_WINDOW, NuvolaInspectorWindowClass))
#define NUVOLA_IS_INSPECTOR_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_INSPECTOR_WINDOW))
#define NUVOLA_IS_INSPECTOR_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_INSPECTOR_WINDOW))
#define NUVOLA_INSPECTOR_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_INSPECTOR_WINDOW, NuvolaInspectorWindowClass))

typedef struct _NuvolaInspectorWindow NuvolaInspectorWindow;
typedef struct _NuvolaInspectorWindowClass NuvolaInspectorWindowClass;

struct _NuvolaWebView {
	WebKitWebView parent_instance;
	NuvolaWebViewPrivate * priv;
};

struct _NuvolaWebViewClass {
	WebKitWebViewClass parent_class;
};

struct _NuvolaWebViewPrivate {
	gdouble dpi;
	gboolean _developer_mode;
	gfloat _scaled_zoom_level;
};


static gpointer nuvola_web_view_parent_class = NULL;

GType nuvola_web_view_get_type (void) G_GNUC_CONST;
#define NUVOLA_WEB_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_WEB_VIEW, NuvolaWebViewPrivate))
enum  {
	NUVOLA_WEB_VIEW_DUMMY_PROPERTY,
	NUVOLA_WEB_VIEW_DEVELOPER_MODE,
	NUVOLA_WEB_VIEW_SCALED_ZOOM_LEVEL
};
#define NUVOLA_WEB_VIEW_DEFAULT_DPI 96.0
NuvolaWebView* nuvola_web_view_new (void);
NuvolaWebView* nuvola_web_view_construct (GType object_type);
void nuvola_web_view_set_developer_mode (NuvolaWebView* self, gboolean value);
static void nuvola_web_view_on_style_updated (NuvolaWebView* self);
static void _nuvola_web_view_on_style_updated_gtk_widget_style_updated (GtkWidget* _sender, gpointer self);
static void nuvola_web_view_real_realize (GtkWidget* base);
static void nuvola_web_view_update_dpi (NuvolaWebView* self);
void nuvola_web_view_set_scaled_zoom_level (NuvolaWebView* self, gfloat value);
void nuvola_web_view_zoom_reset (NuvolaWebView* self);
gboolean nuvola_web_view_get_developer_mode (NuvolaWebView* self);
NuvolaInspectorWindow* nuvola_inspector_window_new (WebKitWebView* view);
NuvolaInspectorWindow* nuvola_inspector_window_construct (GType object_type, WebKitWebView* view);
GType nuvola_inspector_window_get_type (void) G_GNUC_CONST;
gfloat nuvola_web_view_get_scaled_zoom_level (NuvolaWebView* self);
static void nuvola_web_view_finalize (GObject* obj);
static void _vala_nuvola_web_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_web_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Constructs a new Web View
 */
static gpointer _g_object_ref0 (gpointer self) {
#line 75 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	return self ? g_object_ref (self) : NULL;
#line 111 "webview.c"
}


static void _nuvola_web_view_on_style_updated_gtk_widget_style_updated (GtkWidget* _sender, gpointer self) {
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	nuvola_web_view_on_style_updated ((NuvolaWebView*) self);
#line 118 "webview.c"
}


NuvolaWebView* nuvola_web_view_construct (GType object_type) {
	NuvolaWebView * self = NULL;
	WebKitWebSettings* settings = NULL;
	WebKitWebSettings* _tmp0_ = NULL;
	WebKitWebSettings* _tmp1_ = NULL;
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self = (NuvolaWebView*) g_object_new (object_type, NULL);
#line 75 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp0_ = webkit_web_view_get_settings ((WebKitWebView*) self);
#line 75 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 75 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	settings = _tmp1_;
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_set (settings, "enable-caret-browsing", FALSE, NULL);
#line 77 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_set (settings, "enable-plugins", FALSE, NULL);
#line 78 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_set (settings, "javascript-can-open-windows-automatically", FALSE, NULL);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_set (settings, "enable-site-specific-quirks", TRUE, NULL);
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	webkit_web_view_set_settings ((WebKitWebView*) self, settings);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	webkit_web_view_set_full_content_zoom ((WebKitWebView*) self, TRUE);
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	nuvola_web_view_set_developer_mode (self, FALSE);
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_signal_connect_object ((GtkWidget*) self, "style-updated", (GCallback) _nuvola_web_view_on_style_updated_gtk_widget_style_updated, self, G_CONNECT_AFTER);
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_g_object_unref0 (settings);
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	return self;
#line 155 "webview.c"
}


NuvolaWebView* nuvola_web_view_new (void) {
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	return nuvola_web_view_construct (NUVOLA_TYPE_WEB_VIEW);
#line 162 "webview.c"
}


static void nuvola_web_view_real_realize (GtkWidget* base) {
	NuvolaWebView * self;
	gfloat _tmp0_ = 0.0F;
#line 86 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self = (NuvolaWebView*) base;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	nuvola_web_view_update_dpi (self);
#line 88 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	GTK_WIDGET_CLASS (nuvola_web_view_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, WEBKIT_TYPE_WEB_VIEW, WebKitWebView));
#line 89 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp0_ = self->priv->_scaled_zoom_level;
#line 89 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	if (_tmp0_ != 0.0f) {
#line 179 "webview.c"
		gfloat _tmp1_ = 0.0F;
#line 91 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp1_ = self->priv->_scaled_zoom_level;
#line 91 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		nuvola_web_view_set_scaled_zoom_level (self, _tmp1_);
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		self->priv->_scaled_zoom_level = 0.0f;
#line 187 "webview.c"
	}
}


static void nuvola_web_view_update_dpi (NuvolaWebView* self) {
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_ = NULL;
	GdkScreen* _tmp1_ = NULL;
	GdkScreen* _tmp3_ = NULL;
	gdouble _tmp4_ = 0.0;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_return_if_fail (self != NULL);
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp0_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	screen = _tmp0_;
#line 99 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp1_ = screen;
#line 99 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	if (_tmp1_ == NULL) {
#line 208 "webview.c"
		GdkScreen* _tmp2_ = NULL;
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		g_warning ("webview.vala:101: WebView.update_dpi() called without a screen.");
#line 102 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp2_ = gdk_screen_get_default ();
#line 102 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		screen = _tmp2_;
#line 216 "webview.c"
	}
#line 104 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp3_ = screen;
#line 104 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp4_ = gdk_screen_get_resolution (_tmp3_);
#line 104 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self->priv->dpi = _tmp4_;
#line 224 "webview.c"
}


static void nuvola_web_view_on_style_updated (NuvolaWebView* self) {
	gdouble old_dpi = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_return_if_fail (self != NULL);
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp0_ = self->priv->dpi;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	old_dpi = _tmp0_;
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	nuvola_web_view_update_dpi (self);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp1_ = old_dpi;
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp2_ = self->priv->dpi;
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	if (_tmp1_ != _tmp2_) {
#line 247 "webview.c"
		gfloat _tmp3_ = 0.0F;
		gfloat _tmp4_ = 0.0F;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp3_ = webkit_web_view_get_zoom_level ((WebKitWebView*) self);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp4_ = _tmp3_;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp5_ = self->priv->dpi;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp6_ = old_dpi;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		webkit_web_view_set_zoom_level ((WebKitWebView*) self, (gfloat) ((_tmp4_ * _tmp5_) / _tmp6_));
#line 262 "webview.c"
	}
}


/**
 * Resets zoom level
 */
void nuvola_web_view_zoom_reset (NuvolaWebView* self) {
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	nuvola_web_view_set_scaled_zoom_level (self, 1.0f);
#line 275 "webview.c"
}


gboolean nuvola_web_view_get_developer_mode (NuvolaWebView* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp0_ = self->priv->_developer_mode;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	return result;
#line 290 "webview.c"
}


void nuvola_web_view_set_developer_mode (NuvolaWebView* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	WebKitWebSettings* settings = NULL;
	WebKitWebSettings* _tmp1_ = NULL;
	WebKitWebSettings* _tmp2_ = NULL;
	WebKitWebSettings* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	WebKitWebSettings* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	WebKitWebSettings* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_return_if_fail (self != NULL);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp0_ = value;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self->priv->_developer_mode = _tmp0_;
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp1_ = webkit_web_view_get_settings ((WebKitWebView*) self);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	settings = _tmp2_;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp3_ = settings;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp4_ = value;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_set (_tmp3_, "enable-default-context-menu", _tmp4_, NULL);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp5_ = settings;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp6_ = value;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_set (_tmp5_, "enable-developer-extras", _tmp6_, NULL);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp7_ = settings;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	webkit_web_view_set_settings ((WebKitWebView*) self, _tmp7_);
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp8_ = value;
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	if (_tmp8_) {
#line 337 "webview.c"
		NuvolaInspectorWindow* _tmp9_ = NULL;
		NuvolaInspectorWindow* _tmp10_ = NULL;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp9_ = nuvola_inspector_window_new ((WebKitWebView*) self);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		g_object_ref_sink (_tmp9_);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp10_ = _tmp9_;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_g_object_unref0 (_tmp10_);
#line 348 "webview.c"
	}
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_g_object_unref0 (settings);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_notify ((GObject *) self, "developer-mode");
#line 354 "webview.c"
}


gfloat nuvola_web_view_get_scaled_zoom_level (NuvolaWebView* self) {
	gfloat result;
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	gfloat _tmp3_ = 0.0F;
	gdouble _tmp4_ = 0.0;
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp0_ = self->priv->_scaled_zoom_level;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	if (_tmp0_ != 0.0f) {
#line 370 "webview.c"
		gfloat _tmp1_ = 0.0F;
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp1_ = self->priv->_scaled_zoom_level;
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		result = _tmp1_;
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		return result;
#line 378 "webview.c"
	}
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp2_ = webkit_web_view_get_zoom_level ((WebKitWebView*) self);
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp3_ = _tmp2_;
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp4_ = self->priv->dpi;
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	result = (gfloat) ((_tmp3_ * NUVOLA_WEB_VIEW_DEFAULT_DPI) / _tmp4_);
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	return result;
#line 390 "webview.c"
}


void nuvola_web_view_set_scaled_zoom_level (NuvolaWebView* self, gfloat value) {
	gboolean _tmp0_ = FALSE;
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_return_if_fail (self != NULL);
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	_tmp0_ = gtk_widget_get_realized ((GtkWidget*) self);
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	if (_tmp0_) {
#line 402 "webview.c"
		gfloat _tmp1_ = 0.0F;
		gdouble _tmp2_ = 0.0;
#line 64 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp1_ = value;
#line 64 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp2_ = self->priv->dpi;
#line 64 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		webkit_web_view_set_zoom_level ((WebKitWebView*) self, (gfloat) ((_tmp1_ * _tmp2_) / NUVOLA_WEB_VIEW_DEFAULT_DPI));
#line 411 "webview.c"
	} else {
		gfloat _tmp3_ = 0.0F;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		_tmp3_ = value;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		self->priv->_scaled_zoom_level = _tmp3_;
#line 418 "webview.c"
	}
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_notify ((GObject *) self, "scaled-zoom-level");
#line 422 "webview.c"
}


static void nuvola_web_view_class_init (NuvolaWebViewClass * klass) {
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	nuvola_web_view_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_type_class_add_private (klass, sizeof (NuvolaWebViewPrivate));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	((GtkWidgetClass *) klass)->realize = nuvola_web_view_real_realize;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_web_view_get_property;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_web_view_set_property;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	G_OBJECT_CLASS (klass)->finalize = nuvola_web_view_finalize;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_WEB_VIEW_DEVELOPER_MODE, g_param_spec_boolean ("developer-mode", "developer-mode", "developer-mode", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_WEB_VIEW_SCALED_ZOOM_LEVEL, g_param_spec_float ("scaled-zoom-level", "DPI-scaled zoom level", "Zoom level that takes font scaling factor into account.", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 443 "webview.c"
}


static void nuvola_web_view_instance_init (NuvolaWebView * self) {
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self->priv = NUVOLA_WEB_VIEW_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self->priv->dpi = NUVOLA_WEB_VIEW_DEFAULT_DPI;
#line 32 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self->priv->_developer_mode = FALSE;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self->priv->_scaled_zoom_level = 1.0f;
#line 456 "webview.c"
}


static void nuvola_web_view_finalize (GObject* obj) {
	NuvolaWebView * self;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_WEB_VIEW, NuvolaWebView);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	G_OBJECT_CLASS (nuvola_web_view_parent_class)->finalize (obj);
#line 466 "webview.c"
}


/**
 * WebView that has modified some web settings.
 */
GType nuvola_web_view_get_type (void) {
	static volatile gsize nuvola_web_view_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_web_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaWebViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_web_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaWebView), 0, (GInstanceInitFunc) nuvola_web_view_instance_init, NULL };
		GType nuvola_web_view_type_id;
		nuvola_web_view_type_id = g_type_register_static (WEBKIT_TYPE_WEB_VIEW, "NuvolaWebView", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_web_view_type_id__volatile, nuvola_web_view_type_id);
	}
	return nuvola_web_view_type_id__volatile;
}


static void _vala_nuvola_web_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaWebView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_WEB_VIEW, NuvolaWebView);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		case NUVOLA_WEB_VIEW_DEVELOPER_MODE:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		g_value_set_boolean (value, nuvola_web_view_get_developer_mode (self));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		case NUVOLA_WEB_VIEW_SCALED_ZOOM_LEVEL:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		g_value_set_float (value, nuvola_web_view_get_scaled_zoom_level (self));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		break;
#line 502 "webview.c"
		default:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		break;
#line 508 "webview.c"
	}
}


static void _vala_nuvola_web_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaWebView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_WEB_VIEW, NuvolaWebView);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		case NUVOLA_WEB_VIEW_DEVELOPER_MODE:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		nuvola_web_view_set_developer_mode (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		case NUVOLA_WEB_VIEW_SCALED_ZOOM_LEVEL:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		nuvola_web_view_set_scaled_zoom_level (self, g_value_get_float (value));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		break;
#line 530 "webview.c"
		default:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/webview.vala"
		break;
#line 536 "webview.c"
	}
}



